Lorene::MEos Class Reference

EOS with domain dependency. More...

`#include <eos.h>`

Inheritance diagram for Lorene::MEos:

## Public Member Functions

| MEos (int ndom_i, const Eos **mono_eos_i)
| Standard constructor.
| MEos (const Eos &eos1, const Eos &eos2)
| Constructor for 2 domains.
| MEos (const Eos &eos1, const Eos &eos2, const Eos &eos3)
| Constructor for 3 domains.
| MEos (const Eos &eos1, const Eos &eos2, const Eos &eos3, const Eos &eos4)
| Constructor for 4 domains.
| MEos (const MEos &)
| Copy constructor.
virtual | ~MEos ()
| Destructor.
void | operator= (const MEos &)
| Assignment to another `MEos`.
virtual bool | operator== (const Eos &) const
| Comparison operator (egality).
virtual bool | operator!= (const Eos &) const
| Comparison operator (difference).
virtual int | identify () const
| Returns a number to identify the sub-classe of `Eos` the object belongs to.
virtual void | sauve (FILE *) const
| Save in a file.
virtual double | nbar_ent_p (double ent, const Param *par=0x0) const
| Computes the baryon density from the log-enthalpy.
virtual double | ener_ent_p (double ent, const Param *par=0x0) const
| Computes the total energy density from the log-enthalpy.
virtual double | press_ent_p (double ent, const Param *par=0x0) const
| Computes the pressure from the log-enthalpy.
virtual double | der_nbar_ent_p (double ent, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy.
virtual double | der_ener_ent_p (double ent, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy.
virtual double | der_press_ent_p (double ent, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy.
const char * | get_name () const
| Returns the EOS name.
void | set_name (const char *name_i)
| Sets the EOS name.
Cmp | nbar_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the baryon density field from the log-enthalpy field and extra parameters.
Scalar | nbar_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the baryon density field from the log-enthalpy field and extra parameters.
Cmp | ener_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the total energy density from the log-enthalpy and extra parameters.
Scalar | ener_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the total energy density from the log-enthalpy and extra parameters.
Cmp | press_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the pressure from the log-enthalpy and extra parameters.
Scalar | press_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the pressure from the log-enthalpy and extra parameters.
Cmp | der_nbar_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Scalar | der_nbar_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Cmp | der_ener_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Scalar | der_ener_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Cmp | der_press_ent (const Cmp &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.
Scalar | der_press_ent (const Scalar &ent, int nzet, int l_min=0, const Param *par=0x0) const
| Computes the logarithmic derivative from the log-enthalpy and extra parameters.

## Static Public Member Functions

static Eos * | eos_from_file (FILE *)
| Construction of an EOS from a binary file.
static Eos * | eos_from_file (ifstream &)
| Construction of an EOS from a formatted file.

## Protected Member Functions

| MEos (FILE *)
| Constructor from a binary file (created by the function `sauve(FILE*)` ).
| MEos (ifstream &)
| Constructor from a formatted file.
virtual ostream & | operator>> (ostream &) const
| Operator >>.
void | calcule (const Cmp &thermo, int nzet, int l_min, double(Eos::*fait)(double, const Param *) const, const Param *par, Cmp &resu) const
| General computational method for `Cmp` 's.
void | calcule (const Scalar &thermo, int nzet, int l_min, double(Eos::*fait)(double, const Param *) const, const Param *par, Scalar &resu) const
| General computational method for `Scalar` 's.

## Protected Attributes

const Eos ** | mono_eos
| Array (upon the domains) containing the various EOS.
int | ndom
| Number of domains.
bool | constructed_from_file
| Indicates wether the EOS has been constructed from a file.
char | name [100]
| EOS name.

## Friends

Eos * | Eos::eos_from_file (FILE *)
Eos * | Eos::eos_from_file (ifstream &)

## Detailed Description

EOS with domain dependency.

Definition at line 2279 of file eos.h.

## Constructor & Destructor Documentation

## MEos() [1/7]

Lorene::MEos::MEos | ( | int | ndom_i,
|  | const Eos ** | mono_eos_i )

Standard constructor.

Parameters

  ndom_i | number of domains
  mono_eos_i | array (size `ndom_i` ) of pointers on the various EOS

Definition at line 72 of file meos.C.

References constructed_from_file, Lorene::Eos::Eos(), mono_eos, and ndom.

## MEos() [2/7]

Lorene::MEos::MEos | ( | const Eos & | eos1,
|  | const Eos & | eos2 )

Constructor for 2 domains.

Definition at line 85 of file meos.C.

References constructed_from_file, Lorene::Eos::Eos(), mono_eos, and ndom.

## MEos() [3/7]

Lorene::MEos::MEos | ( | const Eos & | eos1,
|  | const Eos & | eos2,
|  | const Eos & | eos3 )

Constructor for 3 domains.

Definition at line 95 of file meos.C.

References constructed_from_file, Lorene::Eos::Eos(), mono_eos, and ndom.

## MEos() [4/7]

Lorene::MEos::MEos | ( | const Eos & | eos1,
|  | const Eos & | eos2,
|  | const Eos & | eos3,
|  | const Eos & | eos4 )

Constructor for 4 domains.

Definition at line 106 of file meos.C.

References constructed_from_file, Lorene::Eos::Eos(), mono_eos, and ndom.

## MEos() [5/7]

Lorene::MEos::MEos | ( | const MEos & | meos | ) |

Copy constructor.

Definition at line 119 of file meos.C.

References constructed_from_file, Lorene::Eos::Eos(), MEos(), mono_eos, and ndom.

## MEos() [6/7]

Lorene::MEos::MEos | ( | FILE * | fich | ) |

protected

Constructor from a binary file (created by the function `sauve(FILE*)` ).

This constructor is protected because any EOS construction from a binary file must be done via the function `Eos::eos_from_file(FILE*)` .

Definition at line 133 of file meos.C.

References constructed_from_file, Lorene::Eos::Eos(), Lorene::Eos::eos_from_file(), Lorene::fread_be(), mono_eos, and ndom.

## MEos() [7/7]

Lorene::MEos::MEos | ( | ifstream & | fich | ) |

protected

Constructor from a formatted file.

This constructor is protected because any EOS construction from a formatted file must be done via the function `Eos::eos_from_file(ifstream&)` . The construction functions from a file

Definition at line 145 of file meos.C.

References constructed_from_file, Lorene::Eos::Eos(), Lorene::Eos::eos_from_file(), mono_eos, and ndom.

## ~MEos()

Lorene::MEos::~MEos | ( |  | ) |

virtual

Destructor.

Definition at line 162 of file meos.C.

References constructed_from_file, mono_eos, and ndom.

## Member Function Documentation

## calcule() [1/2]

void Lorene::Eos::calcule | ( | const Cmp & | thermo,
|  | int | nzet,
|  | int | l_min,
|  | double(Eos::* | fait )(double, const Param *) const,
|  | const Param * | par,
|  | Cmp & | resu ) const

protected inherited

General computational method for `Cmp` 's.

Parameters

  thermo | [input] thermodynamical quantity (for instance the enthalpy field)from which the thermodynamical quantity `resu` is to be computed.
  nzet | [input] number of domains where `resu` is to be computed.
  l_min | [input] index of the innermost domain is which `resu` is to be computed [default value: 0]; `resu` is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  fait | [input] pointer on the member function of class `Eos` which performs the pointwise calculation.
  par | possible extra parameters of the EOS
  resu | [output] result of the computation.

Definition at line 203 of file eos.C.

References Lorene::Cmp::annule(), Lorene::Valeur::c, Lorene::Valeur::coef_i(), Eos(), Lorene::Cmp::get_etat(), Lorene::Tbl::get_etat(), Lorene::Cmp::get_mp(), Lorene::Mg3d::get_nzone(), Lorene::Tbl::get_taille(), Lorene::Map(), Lorene::Valeur::set_etat_c_qcq(), Lorene::Cmp::set_etat_qcq(), Lorene::Mtbl::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Cmp::set_etat_zero(), Lorene::Tbl::set_etat_zero(), Lorene::Mtbl::t, Lorene::Tbl::t, and Lorene::Cmp::va.

## calcule() [2/2]

void Lorene::Eos::calcule | ( | const Scalar & | thermo,
|  | int | nzet,
|  | int | l_min,
|  | double(Eos::* | fait )(double, const Param *) const,
|  | const Param * | par,
|  | Scalar & | resu ) const

protected inherited

General computational method for `Scalar` 's.

Parameters

  thermo | [input] thermodynamical quantity (for instance the enthalpy field)from which the thermodynamical quantity `resu` is to be computed.
  nzet | [input] number of domains where `resu` is to be computed.
  l_min | [input] index of the innermost domain is which `resu` is to be computed [default value: 0]; `resu` is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  fait | [input] pointer on the member function of class `Eos` which performs the pointwise calculation.
  par | possible extra parameters of the EOS
  resu | [output] result of the computation.

Definition at line 268 of file eos.C.

References Lorene::Scalar::annule(), Lorene::Valeur::c, Lorene::Valeur::coef_i(), Eos(), Lorene::Scalar::get_etat(), Lorene::Tbl::get_etat(), Lorene::Tensor::get_mp(), Lorene::Mg3d::get_nzone(), Lorene::Scalar::get_spectral_va(), Lorene::Tbl::get_taille(), Lorene::Map(), Lorene::Valeur::set_etat_c_qcq(), Lorene::Mtbl::set_etat_qcq(), Lorene::Scalar::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Scalar::set_etat_zero(), Lorene::Tbl::set_etat_zero(), Lorene::Scalar::set_spectral_va(), Lorene::Mtbl::t, and Lorene::Tbl::t.

## der_ener_ent() [1/2]

Cmp Lorene::Eos::der_ener_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(e)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(e)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(e)/dln(H)

Definition at line 430 of file eos.C.

References calcule(), der_ener_ent_p(), and Lorene::Cmp::get_mp().

## der_ener_ent() [2/2]

Scalar Lorene::Eos::der_ener_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(e)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(e)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(e)/dln(H)

Definition at line 440 of file eos.C.

References calcule(), der_ener_ent_p(), and Lorene::Tensor::get_mp().

## der_ener_ent_p()

double Lorene::MEos::der_ener_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the logarithmic derivative from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  dln(e)/dln(H)

Implements Lorene::Eos.

Definition at line 305 of file meos.C.

References Lorene::Param::get_int(), and mono_eos.

## der_nbar_ent() [1/2]

Cmp Lorene::Eos::der_nbar_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(n)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(n)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(n)/dln(H)

Definition at line 407 of file eos.C.

References calcule(), der_nbar_ent_p(), and Lorene::Cmp::get_mp().

## der_nbar_ent() [2/2]

Scalar Lorene::Eos::der_nbar_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(n)/dln(H) is to be computed.
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(n)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  dln(n)/dln(H)

Definition at line 417 of file eos.C.

References calcule(), der_nbar_ent_p(), and Lorene::Tensor::get_mp().

## der_nbar_ent_p()

double Lorene::MEos::der_nbar_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the logarithmic derivative from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  dln(n)/dln(H)

Implements Lorene::Eos.

Definition at line 295 of file meos.C.

References Lorene::Param::get_int(), and mono_eos.

## der_press_ent() [1/2]

Cmp Lorene::Eos::der_press_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(p)/dln(H) is to be computed.
  par | possible extra parameters of the EOS
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(p)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.

Returns
  dln(p)/dln(H)

Definition at line 452 of file eos.C.

References calcule(), der_press_ent_p(), and Lorene::Cmp::get_mp().

## der_press_ent() [2/2]

Scalar Lorene::Eos::der_press_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the logarithmic derivative from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the derivative dln(p)/dln(H) is to be computed.
  par | possible extra parameters of the EOS
  l_min | index of the innermost domain is which the coefficient dln(n)/dln(H) is to be computed [default value: 0]; the derivative dln(p)/dln(H) is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.

Returns
  dln(p)/dln(H)

Definition at line 462 of file eos.C.

References calcule(), der_press_ent_p(), and Lorene::Tensor::get_mp().

## der_press_ent_p()

double Lorene::MEos::der_press_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the logarithmic derivative from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  dln(p)/dln(H)

Implements Lorene::Eos.

Definition at line 315 of file meos.C.

References Lorene::Param::get_int(), and mono_eos.

## ener_ent() [1/2]

Cmp Lorene::Eos::ener_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the total energy density from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the energy density is to be computed.
  l_min | index of the innermost domain is which the energy density is to be computed [default value: 0]; the energy density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  energy density [unit: ], where

Definition at line 363 of file eos.C.

References calcule(), ener_ent_p(), and Lorene::Cmp::get_mp().

## ener_ent() [2/2]

Scalar Lorene::Eos::ener_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the total energy density from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the energy density is to be computed.
  l_min | index of the innermost domain is which the energy density is to be computed [default value: 0]; the energy density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  energy density [unit: ], where

Definition at line 373 of file eos.C.

References calcule(), ener_ent_p(), and Lorene::Tensor::get_mp().

## ener_ent_p()

double Lorene::MEos::ener_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the total energy density from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  energy density e [unit: ], where

Implements Lorene::Eos.

Definition at line 275 of file meos.C.

References Lorene::Param::get_int(), and mono_eos.

## eos_from_file() [1/2]

Eos * Lorene::Eos::eos_from_file | ( | FILE * | fich | ) |

static inherited

Construction of an EOS from a binary file.

The file must have been created by the function `sauve(FILE*)` .

Definition at line 177 of file eos_from_file.C.

References Eos(), and Lorene::fread_be().

## eos_from_file() [2/2]

Eos * Lorene::Eos::eos_from_file | ( | ifstream & | fich | ) |

static inherited

Construction of an EOS from a formatted file.

The fist line of the file must start by the EOS number, according to the following conventions:

- 1 = relativistic polytropic EOS (class `Eos_poly` ).
- 2 = Newtonian polytropic EOS (class `Eos_poly_newt` ).
- 3 = Relativistic incompressible EOS (class `Eos_incomp` ).
- 4 = Newtonian incompressible EOS (class `Eos_incomp_newt` ).
- 5 = Strange matter (MIT Bag model)
- 6 = Strange matter (MIT Bag model) with crust
- 10 = SLy4 (Douchin & Haensel 2001)
- 11 = FPS (Friedman-Pandharipande + Skyrme)
- 12 = BPAL12 (Bombaci et al. 1995)
- 13 = AkmalPR (Akmal, Pandharipande & Ravenhall 1998)
- 14 = BBB2 (Baldo, Bombaci & Burgio 1997)
- 15 = BalbN1H1 (Balberg 2000)
- 16 = GlendNH3 (Glendenning 1985, case 3)
- 17 = Compstar (Tabulated EOS for 2010 CompStar school)
- 18 = magnetized (tabulated) equation of state
- 19 = relativistic ideal Fermi gas at zero temperature (class `Eos_Fermi`)
- 100 = Multi-domain EOS (class `MEos` )
- 110 = Multi-polytropic EOS (class `Eos_multi_poly` )
- 120 = Fitted SLy4 (Shibata 2004)
- 121 = Fitted FPS (Shibata 2004)
- 122 = Fitted AkmalPR (Taniguchi 2005)

The second line in the file should contain a name given by the user to the EOS. The following lines should contain the EOS parameters (one parameter per line), in the same order than in the class declaration.

Definition at line 314 of file eos_from_file.C.

References Eos().

## get_name()

const char * Lorene::Eos::get_name | ( |  | ) | const

inherited

Returns the EOS name.

Definition at line 169 of file eos.C.

References name.

## identify()

int Lorene::MEos::identify | ( |  | ) | const

virtual

Returns a number to identify the sub-classe of `Eos` the object belongs to.

Implements Lorene::Eos.

Definition at line 163 of file eos_from_file.C.

## nbar_ent() [1/2]

Cmp Lorene::Eos::nbar_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the baryon density field from the log-enthalpy field and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the baryon density is to be computed.
  l_min | index of the innermost domain is which the baryon density is to be computed [default value: 0]; the baryon density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  baryon density [unit: ]

Definition at line 338 of file eos.C.

References calcule(), Lorene::Cmp::get_mp(), and nbar_ent_p().

## nbar_ent() [2/2]

Scalar Lorene::Eos::nbar_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the baryon density field from the log-enthalpy field and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the baryon density is to be computed.
  l_min | index of the innermost domain is which the baryon density is to be computed [default value: 0]; the baryon density is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  baryon density [unit: ]

Definition at line 348 of file eos.C.

References calcule(), Lorene::Tensor::get_mp(), and nbar_ent_p().

## nbar_ent_p()

double Lorene::MEos::nbar_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the baryon density from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  baryon density n [unit: ]

Implements Lorene::Eos.

Definition at line 264 of file meos.C.

References Lorene::Param::get_int(), and mono_eos.

## operator!=()

bool Lorene::MEos::operator!= | ( | const Eos & | eos_i | ) | const

virtual

Comparison operator (difference).

Implements Lorene::Eos.

Definition at line 250 of file meos.C.

References Lorene::Eos::Eos(), and operator==().

## operator=()

void Lorene::MEos::operator= | ( | const MEos & |  | ) |

Assignment to another `MEos`.

Definition at line 178 of file meos.C.

References MEos().

## operator==()

bool Lorene::MEos::operator== | ( | const Eos & | eos_i | ) | const

virtual

Comparison operator (egality).

Implements Lorene::Eos.

Definition at line 222 of file meos.C.

References Lorene::Eos::Eos(), Lorene::Eos::identify(), identify(), MEos(), mono_eos, and ndom.

## operator>>()

ostream & Lorene::MEos::operator>> | ( | ostream & | ost | ) | const

protected virtual

Operator >>.

Implements Lorene::Eos.

Definition at line 202 of file meos.C.

References mono_eos, and ndom.

## press_ent() [1/2]

Cmp Lorene::Eos::press_ent | ( | const Cmp & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the pressure from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the pressure is to be computed.
  l_min | index of the innermost domain is which the pressure is to be computed [default value: 0]; the pressure is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  pressure [unit: ], where

Definition at line 385 of file eos.C.

References calcule(), Lorene::Cmp::get_mp(), and press_ent_p().

## press_ent() [2/2]

Scalar Lorene::Eos::press_ent | ( | const Scalar & | ent,
|  | int | nzet,
|  | int | l_min = 0,
|  | const Param * | par = 0x0 ) const

inherited

Computes the pressure from the log-enthalpy and extra parameters.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by , where e is the (total) energy density, p the pressure, n the baryon density, and the baryon mass
  nzet | number of domains where the pressure is to be computed.
  l_min | index of the innermost domain is which the pressure is to be computed [default value: 0]; the pressure is computed only in domains whose indices are in ``[l_min,l_min+nzet-1] . In the other domains, it is set to zero.
  par | possible extra parameters of the EOS

Returns
  pressure [unit: ], where

Definition at line 395 of file eos.C.

References calcule(), Lorene::Tensor::get_mp(), and press_ent_p().

## press_ent_p()

double Lorene::MEos::press_ent_p | ( | double | ent,
|  | const Param * | par = 0x0 ) const

virtual

Computes the pressure from the log-enthalpy.

Parameters

  ent | [input, unit: ] log-enthalpy H defined by Eq. (4)
  par | possible extra parameters of the EOS

Returns
  pressure p [unit: ], where

Implements Lorene::Eos.

Definition at line 285 of file meos.C.

References Lorene::Param::get_int(), and mono_eos.

## sauve()

void Lorene::MEos::sauve | ( | FILE * | fich | ) | const

virtual

Save in a file.

Reimplemented from Lorene::Eos.

Definition at line 190 of file meos.C.

References Lorene::fwrite_be(), mono_eos, ndom, and Lorene::Eos::sauve().

## set_name()

void Lorene::Eos::set_name | ( | const char * | name_i | ) |

inherited

Sets the EOS name.

Definition at line 163 of file eos.C.

References name.

## Member Data Documentation

## constructed_from_file

bool Lorene::MEos::constructed_from_file

protected

Indicates wether the EOS has been constructed from a file.

Definition at line 2292 of file eos.h.

## mono_eos

const Eos** Lorene::MEos::mono_eos

protected

Array (upon the domains) containing the various EOS.

Definition at line 2286 of file eos.h.

## name

char Lorene::Eos::name[100]

protected inherited

EOS name.

Definition at line 196 of file eos.h.

## ndom

int Lorene::MEos::ndom

protected

Number of domains.

Definition at line 2289 of file eos.h.

The documentation for this class was generated from the following files:

- eos.h
- eos_from_file.C
- meos.C